HDU-4323Magic Number

Problem Description
There are many magic numbers whose lengths are less than 10. Given some queries, each contains a single number, if the Levenshtein distance (see below) between the number in the query and a magic number is no more than a threshold, we call the magic number is the lucky number for that query. Could you find out how many luck numbers are there for each query?

Levenshtein distance (from Wikipedia http://en.wikipedia.org/wiki/Levenshtein_distance):
In information theory and computer science, the Levenshtein distance is a string metric for measuring the amount of difference between two sequences. The term edit distance is often used to refer specifically to Levenshtein distance.
The Levenshtein distance between two strings is defined as the minimum number of edits needed to transform one string into the other, with the allowable edit operations being insertion, deletion, or substitution of a single character. It is named after Vladimir Levenshtein, who considered this distance in 1965.
For example, the Levenshtein distance between "kitten" and "sitting" is 3, since the following three edits change one into the other, and there is no way to do it with fewer than three edits:
1.kitten → sitten (substitution of 's' for 'k')
2.sitten → sittin (substitution of 'i' for 'e')
3.sittin → sitting (insertion of 'g' at the end).

Input
There are several test cases. The first line contains a single number T shows that there are T cases. For each test case, there are 2 numbers in the first line: n (n <= 1500) m (m <= 1000) where n is the number of magic numbers and m is the number of queries.
In the next n lines, each line has a magic number. You can assume that each magic number is distinctive.
In the next m lines, each line has a query and a threshold. The length of each query is no more than 10 and the threshold is no more than 3.
 

Output
For each test case, the first line is "Case #id:", where id is the case number. Then output m lines. For each line, there is a number shows the answer of the corresponding query.


一道最短编辑距离,题目数据不算很强,所以暴力的找了一遍也过了。似乎正规解法是用BK书。

Code:
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<math.h>
using namespace std;
char num[1505][15],s[15];
int dp[15][15],lenb,th,lena[1505];
int Edit(int x)
{
    int i,j,Insert,Delete,Replace;
    if(abs(lena[x]-lenb)>th) return 1e9;
    for(i = 0;i<=lena[x];i++) dp[i][0]=i;
    for(j = 0;j<=lenb;j++) dp[0][j]=j;
    for(i = 1;i<=lena[x];i++)
        for(j = 1;j<=lenb;j++)
    {
        Insert=dp[i][j-1]+1;  
        Delete=dp[i-1][j]+1;    
        if(num[x][i-1]==s[j-1]) Replace=dp[i-1][j-1];
        else Replace=dp[i-1][j-1]+1;
        dp[i][j]=min(min(Insert,Delete),Replace);
    }
    return dp[lena[x]][lenb];
}
int main()
{
    int T,Case;
    scanf("%d",&T);
    for(Case=1;Case<=T;Case++)
    {
        int n,m,i,j,ans;
        scanf("%d%d",&n,&m);
        for(i = 0;i<n;i++)
            scanf("%s",num[i]),lena[i]=strlen(num[i]);
              printf("Case #%d:\n",Case);
        for(i = 0;i < m;i++)
        {
            scanf("%s%d",s,&th);
            lenb=strlen(s);ans=0;
            for(j = 0;j<n;j++)
            {
                if(abs(lena[j]-lenb)<=th)
                if(Edit(j)<=th) ans++;
            }
         printf("%d\n",ans);
        }
    }
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值